/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_support.S 1019 2013-07-11 13:29:21Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼 ֥ARMѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"


/*
 *  ץå2Υ֡ѥ
 *  SDRAM(0x00)˥ԡ
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(prc2_boot)
    AGLOBAL(prc2_boot_end)
ALABEL(prc2_boot)
	movw  r1, #(SYSMGR_CPU1STARTADDR & 0xffff)
	movt  r1, #((SYSMGR_CPU1STARTADDR >> 16) & 0xffff)
	ldr   r0, [r1]
	bx    r0
ALABEL(prc2_boot_end)

#ifdef TOPPERS_SAFEG_SECURE
/*
 *  ϤNT˥å˸ƤӽФ륳
 *  SRAM˥ԡƻѤ롥
 */
    ATEXT
    AALIGN(2)
    AGLOBAL(first_switch_to_nt)
    AGLOBAL(first_switch_to_nt_end)
ALABEL(first_switch_to_nt)
	my_core_index r0
	cmp   r0, #1
	beq   safeg_prc2_boot
	movw  r1, #(TARGET_PRC1_NS_START_ADDR & 0xffff)
	movt  r1, #((TARGET_PRC1_NS_START_ADDR >> 16) & 0xffff)
	bx    r1
safeg_prc2_boot:
	movw  r1, #(SYSMGR_CPU1STARTADDR & 0xffff)
	movt  r1, #((SYSMGR_CPU1STARTADDR >> 16) & 0xffff)
1:
	ldr   r0, [r1]
	cmp   r0, #0
	beq   1b
	bx    r0
ALABEL(first_switch_to_nt_end)
#endif /* TOPPERS_SAFEG_SECURE */
